/*
 *  ofSwipeGestureRecognizer.h
 *
 *  Originally Created by Ryan Raffa on 5/13/12.
 *
 *  Based on sample code posted by daanvanhasselt on the openFrameworks forum
 *
 * C++ wrapper and events by Jesus Gollonet
 * at the imal mobile workshop http://www.imal.org/en/activity/mobile-apps-workshop
 *
 */

#import <Foundation/Foundation.h>  

#include "ofMain.h"
#include "ofxiPhoneExtras.h"

enum ofxiOSSwipeDirection {
	OFXIOS_SWIPE_DIRECTION_LEFT,
	OFXIOS_SWIPE_DIRECTION_RIGHT,
	OFXIOS_SWIPE_DIRECTION_UP,
    OFXIOS_SWIPE_DIRECTION_DOWN
};


class ofxiOSSwipeRecognizer;

@interface ofSwipeGestureRecognizer : NSObject {
    UISwipeGestureRecognizer * swipeGestureRecognizer;
    ofxiOSSwipeRecognizer    * notifier;
    ofxiOSSwipeDirection       direction;
}

-(id)   initWithView:   (UIView                   *) view;
-(void) setNotifier:    (ofxiOSSwipeRecognizer    *) _notifier;
-(void) setDirection:   (ofxiOSSwipeDirection      ) _direction;
-(void) handleSwipe:    (UISwipeGestureRecognizer *) gr;

@end
//---------------------------------------------------------------------------------


class ofxiOSSwipeEventArgs{
    public:
        ofxiOSSwipeDirection direction;
        int numTouches;
};

class ofxiOSSwipeRecognizer {
    public:
        ofxiOSSwipeRecognizer();
        void setup(ofxiOSSwipeDirection _direction = OFXIOS_SWIPE_DIRECTION_LEFT);

        void gestureRecognized(ofxiOSSwipeEventArgs args);
        ofSwipeGestureRecognizer * swipeRecognizer;
        ofEvent<ofxiOSSwipeEventArgs> swipeRecognized;
};